;;; guile-irrlicht --- FFI bindings for Irrlicht Engine
;;; Copyright (C) 2020 Javier Sancho <jsf@jsancho.org>
;;;
;;; This file is part of guile-irrlicht.
;;;
;;; Guile-irrlicht is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU Lesser General Public License as
;;; published by the Free Software Foundation; either version 3 of the
;;; License, or (at your option) any later version.
;;;
;;; Guile-irrlicht is distributed in the hope that it will be useful, but
;;; WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;; General Public License for more details.
;;;
;;; You should have received a copy of the GNU Lesser General Public
;;; License along with guile-irrlicht.  If not, see
;;; <http://www.gnu.org/licenses/>.


(define-module (irrlicht)
  #:use-module (oop goops)
  #:use-module (irrlicht base)
  #:use-module (irrlicht core)
  #:use-module (irrlicht device)
  #:use-module (irrlicht gui)
  #:use-module (irrlicht io)
  #:use-module (irrlicht irr)
  #:use-module (irrlicht scene)
  #:use-module (irrlicht video)
  #:duplicates (merge-generics)
  #:re-export (;; classes
               <animated-mesh>
               <animated-mesh-scene-node>
               <attribute-exchanging-object>
               <box3d>
               <camera-scene-node>
               <cursor-control>
               <event>
               <event-receiver>
               <file-archive>
               <file-system>
               <gui-button>
               <gui-editbox>
               <gui-element>
               <gui-environment>
               <gui-font>
               <gui-image>
               <gui-listbox>
               <gui-scrollbar>
               <gui-skin>
               <gui-static-text>
               <irrlicht-device>
               <key-map>
               <material>
               <mesh>
               <mesh-scene-node>
               <reference-counted>
               <scene-manager>
               <scene-node>
               <scene-node-animator>
               <texture>
               <timer>
               <vertex3d>
               <video-driver>
               ;; methods
               add-animated-mesh-scene-node!
               add-animator!
               add-button!
               add-camera-scene-node!
               add-camera-scene-node-fps!
               add-cube-scene-node!
               add-custom-scene-node!
               add-editbox!
               add-file-archive!
               add-image!
               add-internal-point!
               add-listbox!
               add-octree-scene-node!
               add-scrollbar!
               add-sphere-scene-node!
               add-static-text!
               begin-scene
               create-device
               create-fly-circle-animator
               create-fly-straight-animator
               create-rotation-animator
               draw-vertex-primitive-list
               drop!
               end-scene
               get-absolute-transformation
               get-built-in-font
               get-color
               get-cursor-control
               get-event-key
               get-event-key-pressed
               get-event-type
               get-file-system
               get-font
               get-fps
               get-gui-environment
               get-mesh
               get-name
               get-root-scene-node
               get-scene-manager
               get-skin
               get-texture
               get-time
               get-timer
               get-video-driver
               is-window-active?
               make-box3d
               make-event-receiver
               make-material
               make-vertex3d
               reset-box3d!
               run
               set-animation-speed!
               set-color!
               set-event-receiver!
               set-font!
               set-frame-loop!
               set-material!
               set-material-flag!
               set-material-texture!
               set-max!
               set-md2-animation!
               set-override-color!
               set-resizable!
               set-rotation!
               set-scale!
               set-transform!
               set-visible!
               set-window-caption!
               yield-device))

;; Merged methods have to be exported apart
(re-export draw-all
           get-position
           set-position!)
